package core

import (
	"git.urbach.dev/cli/q/src/asm"
	"git.urbach.dev/cli/q/src/cpu"
	"git.urbach.dev/cli/q/src/eval"
)

// ValueToRegister moves a value into a register.
func (f *Function) ValueToRegister(value eval.Value, register cpu.Register) {
	switch value := value.(type) {
	case *eval.Number:
		f.RegisterNumber(asm.MOVE, register, value.Number)
	case *eval.Register:
		f.RegisterRegister(asm.MOVE, register, value.Register)
	case *eval.Memory:
		f.MemoryRegister(asm.LOAD, value.Memory, register)
	case *eval.Label:
		f.RegisterLabel(asm.MOVE, register, value.Label)
	}
}
